# Čerpací stanice

Česká dálniční síť je tvořena $N$ městy a $N-1$ silnicemi
známé délky. Délky silnic udáváme v kilometrech.
Víme, že mezi každou dvojicí měst existuje právě jedna cesta.
Víme také, že v každém městě je právě jedna čerpací stanice (benzínová pumpa) a nikde jinde žádné čerpací stanice nejsou.

Jednoho dne se několik lidí rozhodlo podniknout výlet autem.
Na cestu se vydalo celkem $N^2$ aut.
Kupodivu nastala taková situace, že pro každou uspořádanou dvojici měst $(a,b)$ právě jedno auto jelo z města $a$ do města $b$ (po jediné cestě vedoucí mezi těmito dvěma městy).
Protože v Čechách všichni používají auta značky Škoda,
všechna auta mají benzínovou nádrž stejné kapacity $K$ litrů
a mají také stejnou spotřebu jeden litr benzínu na ujetý kilometr.
Na začátku jízdy mají všechna auta plnou nádrž.
Čeští řidiči se navíc chovají velmi předvídatelným způsobem.
Vzhledem ke své lenosti tankují až ve chvíli, když už nemají dostatek benzínu na to, aby dojeli do dalšího města (je možné přijet do města i se zcela prádnou nádrží).
Jakmile jsou nuceni zastavit na čerpací stanici, vždy natankují plnou nádrž.

Český daňový úřad by o každé čerpací stanici rád zjistil, kolik aut u ní během dne zastavilo.
Vzhledem k předvídatelnému chování řidičů byste to měli umět snadno vypočítat.

## Vstup
První řádek vstupu obsahuje dvě celá čísla $N$ a $K$ oddělená mezerou —
počet měst a kapacita benzínové nádrže každého auta.
Dalších $N-1$ řádků vstupu popisuje jednotlivé silnice.
Na každém z nich jsou tři celá čísla $u_i$, $v_i$ a $l_i$ oddělená mezerami,
kde $u_i$ a $v_i$ jsou indexy měst spojených $i$-tou silnicí a
$l_i$ je délka této silnice v kilometrech.
Města jsou očíslována od $0$ do $N-1$.
Je zaručeno, že mezi každou dvojicí měst vede právě jedna cesta.

## Výstup
Váš program musí vypsat přesně $N$ řádků, obsahujících postupně počet aut, která zastavila u čerpacích stanic ve městech $0$, $1$, ..., $N-1$.

## Příklady

### Příklad 1

Vstup:

```
3 1
0 1 1
1 2 1
```

Výstup:

```
0
2
0
```

V jedné řadě za sebou jsou tři města spojená silnicemi délky 1.
Auta mají kapacitu nádrže 1 litr.
Pouze auta jedoucí mezi oběma okrajovými městy budou tankovat v prostředním městě.

### Příklad 2

Vstup:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Výstup:

```
0
3
3
12
8
0
```

Nyní máme šest měst v jedné řadě a auta mají nádrž s kapacitou 2 litry.
Mnoho aut musí zastavit u čerpacích stanic ve městech 3 a 4.
To dává smysl, protože města 3 a 4 jsou spojena silnicí délky 2 kilometry.

## Omezení
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (pro každé $i$ takové, že $0 \leq i \leq N-2$)

## Podúlohy
Nechť $D$ označuje maximální počet silnic vedoucích z jednoho města.

1. (18 bodů) $N \leq 1\,000, K \leq 1\,000$
2. (8 bodů) $D\le 2$ a $l_i = 1$ (pro každé $i$ takové, že $0 \leq i \leq N-2$)
3. (10 bodů) $D\le 2$
4. (12 bodů) $K\leq 10, D\leq 10$
5. (17 bodů) $K\leq 10$
6. (35 bodů) _žádná další omezení_
