# Tankstellen

Das österreichische Autobahnnetz besteht aus $N$ Städten und $N-1$ Straßen. Wir wissen, dass es genau einen Pfad zwischen jedem Paar an Städten gibt. Wir wissen auch die Länge jeder Straße in Kilometern. Ebenso gibt es in jeder Stadt genau eine Tankstelle. Aufgrund von Budgetproblemen gibt es keine Tankstellen außerhalb von den Städten.

Es ist der erste sonnige Sonntag im Jahr. Und natürlich steht jetzt für jeden Österreicher ein Sonntagsausflug an. Das haben wir schließlich immer schon so gemacht. Gefahren wird mit dem Auto. Insgesamt sind $N^2$ Autos unterwegs. Komischerweise ist für jedes geordneten Paar an Städten $(a,b)$ genau ein Auto auf dem einzigen Pfad von $a$ nach $b$ unterwegs. Da alle BMW fahren haben alle Autos dieselbe Tankgröße von $K$ Litern. Deswegen ist der Benzinverbrauch auch für alle 1 Liter pro gefahrenem Kilometer. Vor dem Start ist der Tank jedes Autos voll. Glücklicherweise sind die Österreicher sehr berechenbar. Da sie sehr faul sind, tanken sie nur nach, wenn sie nicht mehr genügend Benzin haben, um zu der nächsten Tankstelle zu gelangen (Es ist möglich eine Stadt mit leerem Tank zu betreten). Wenn sie gezwungen sind, an einer Tankstelle stehen zu bleiben, füllen sie ihren Tank immer voll.

Die ASFINAG möchte nun wissen, wie viele Autos an diesem Tag an jeder Tankstelle stehen geblieben sind. Da das Verhalten der Leute vorhersehbar ist, sollte es für dich ein Leichtes sein, das zu berechnen.

## Eingabe
Die erste Zeile des Inputs enthält zwei durch ein Leerzeichen getrennte Ganzzahlen $N$ und $K$ — die Anzahl der Städte, sowie die Kapazität des Tanks von jedem Auto.
Die nächsten $N-1$ Zeilen beschreiben die Straßen.
Jede enthält drei durch jeweils ein Leerzeichen getrennte Ganzzahlen $u_i$ $v_i$ und $l_i$. $u_i$ und $v_i$ sind die Indizes der Städte, die durch die $i$-te Straße verbunden sind. $l_i$ ist die Länge der Straße in Kilometer. Die Städte sind von $0$ bis $N-1$ durchnummeriert. Es ist garantiert, dass für jedes Paar an Städten genau ein Pfad zwischen ihnen existiert. 

## Ausgabe
Es sollen $N$ Zeilen ausgegeben werden. In der $i$-ten Zeile soll die Anzahl an Autos ausgegeben werden die an der Tankstelle der $i$-ten Stadt gehalten haben, geordnet von $0$ bis $N-1$.

 <div style='page-break-after: always'></div>

## Beispiele

### Beispiel 1

Eingabe:

```
3 1
0 1 1
1 2 1
```

Ausgabe:

```
0
2
0
```

Es gibt drei Städte in einer Linie, welche durch Straßen der Länge 1 verbunden sind. Die Kapazität des Tanks beträgt einen Liter. Nur die Autos welche zwischen den äußeren Städten fahren halten in der mittleren Stadt an.

### Beispiel 2

Eingabe:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Ausgabe:

```
0
3
3
12
8
0
```

Diesmal sind 6 Städte in einer Linie. Die Kapazität des Tanks beträgt 2 Liter.
Viele Autos müssen in den Städten 3 und 4 stehen bleiben. Das ist nachvollziehbar da die Städte 3 und 4 durch eine Straße der Länge 2 verbunden sind.

## Beschränkungen
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (für jedes $i$ mit $0 \leq i \leq N-2$)

## Teilaufgaben
Sei $D$ die maximale Anzahl an Straßen, die mit einer Stadt verbunden sind.

1. (18 points) $N \leq 1\,000, K \leq 1\,000$
2. (8 points) $D\le 2$ und $l_i = 1$ (für jedes $i$ mit $0 \leq i \leq N-2$)
3. (10 points) $D\le 2$
4. (12 points) $K\leq 10, D\leq 10$
5. (17 points) $K\leq 10$
6. (35 points) _Keine zusätzlichen Beschränkungen_
