# Tankstellen

Das Tschechische Strassennetz besteht aus $N$ Städten und $N-1$ Strassen, deren Länge in Kilometern bekannt ist.
Es ist auch bekannt, dass jedes Paar von Städten durch genau einen Pfad verbunden wird. Ausserdem gibt es in jeder Stadt genau eine Tankstelle, während sich ausserhalb dieser Städte keine Tankstellen befinden.

Eines Tages entschieden sich einige Mäuse, eine Spritztour mit dem Auto zu machen.
Dabei waren insgesamt $N^2$ Autos unterwegs. Merkwürdigerweise gab es für jedes geordnete Paar $(a,b)$ von Städten genau ein Auto, das von Stadt $a$ zu Stadt $b$ fuhr.
Weil alle Mäuse Tschechiens ein Auto der Marke Škoda verwenden, hat der Tank eines jeden Autos die gleiche Kapazität $K$ und jedes Auto verbrennt pro Kilometer genau einen Liter Benzin. Vor Fahrtantritt sind die Tanks aller Autos voll. Auch abgesehen davon ist das Verhalten der Mäuse recht vorhersehbar: Weil sie faul sind, tanken sie nur dann, wenn sie die nächste Stadt mit der im Tank verbleibenden Menge Benzin nicht mehr erreichen würden (Dabei ist es möglich, in einer Stadt mit leerem Tank anzukommen). Sobald sie gezwungen sind, eine Tankstelle aufzusuchen, machen sie den Tank immer randvoll.

Die mit der Erhebung der Steuern befasste Behörde würde gerne für jede Tankstelle wissen, wie viele Autos an diesem Tag an ebenjener Tankstelle hielten.
Weil sich die Mäuse so vorhersehbar verhalten, sollte es dir nicht schwer fallen, dies zu berechnen.

## Eingabe
Die erste Zeile der Eingabe enthält zwei durch Leerzeichen voneinander getrennte Ganzzahlen $N$ und $K$ - die Anzahl der Städte und die Kapazität des Tanks eines jeden Autos.
Die folgenden $N-1$ Zeichen beschreiben die Strassen. Von diesen enthält jede drei durch Leerzeichen voneinander getrennte Ganzzahlen $u_i$, $v_i$ und $l_i$, wobei $u_i$ und $v_i$ die Indizes der durch die $i$-te Strasse verbundenen Städte und $l_i$ die Länge dieser Strasse in Kilometern ist. Dabei werden die Städte von $0$ bis $N-1$ durchnummeriert.
Es ist garantiert, dass für jedes Paar von Städten genau ein Pfad zwischen diesen beiden Städten existiert.

## Ausgabe
Deine Ausgabe muss $N$ Zeilen umfassen, die für jede Stadt die Anzahl von Autos, die dort tanken, enthalten.
Diese sollen von Stadt $0$ bis Stadt $N-1$ geordnet sein.

## Beispiele

### Beispiel 1

Eingabe:

```
3 1
0 1 1
1 2 1
```

Ausgabe:

```
0
2
0
```

Es gibt drei Städte in einer Linie, die von Strassen der Länge 1 miteinander verbunden werden. Jedes Auto hat eine Tankkapazität von 1 Liter.
Nur die Autos, die zwischen den äusseren beiden Städten hin- und herfahren, halten in der mittleren Stadt an.

### Beispiel 2

Eingabe:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Ausgabe:

```
0
3
3
12
8
0
```

Hier gibt es sechs Städte in einer Linie und die Tankkapazität eines jeden Autos ist 2 Liter. Viele Autos müssen in den Städten 3 und 4 anhalten. Das ist sinnvoll, weil diese beiden durch eine 2 Kilometer lange Strasse miteinander verbunden sind.

## Beschränkungen
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (für jedes $i$ mit $0\leq i\leq N-2$)

## Teilaufgaben
Sei $D$ die maximale Anzahl von Strassen, mit denen eine einzige Stadt verbunden ist.

1. (18 Punkte) $N \leq 1\,000, K \leq 1\,000$
2. (8 Punkte) $D\le 2$ und $l_i = 1$ (für jedes $i$ mit $0\leq i\leq N-2$)
3. (10 Punkte) $D\le 2$
4. (12 Punkte) $K\leq 10, D\leq 10$
5. (17 Punkte) $K\leq 10$
6. (35 Punkte) _Keine weiteren Beschränkungen_
