# תחנות דלק

רשת הכבישים המהירים הצ'כית מורכבת מ-$N$ ערים ומ-$N-1$ כבישים
באורכים ידועים בקילומטרים.
אנחנו יודעים שקיים בדיוק מסלול אחד בין כל זוג ערים.
יתר על כן, קיימת בדיוק תחנת דלק אחת בכל אחת מהערים
ולא בשום מקום אחר.

יום אחד, מספר אנשים החליטו לצאת לנסיעה במכונית.
היו בסך הכל $N^2$ מכוניות שנסעו.
באופן מוזר, מתקיים שלכל זוג סדור של ערים $(a,b)$ הייתה
בדיוק מכונית אחת שנסעה מהעיר $a$ לעיר $b$,
בנסיעה לאורך המסלול היחיד בין ערים אלו.
משום שכולם בצ'כיה משתמשים במכוניות סקודה,
לכל מכונית אותה הקיבולת של מיכל הדלק של $K$ ליטרים
והן צורכות באופן קבוע ליטר אחד של דלק לכל קילומטר של נסיעה.
לפני היציאה, מיכל הדלק של כל אחת מהמכוניות מלא.
יתר על כן, הצ'כים יחסית צפויים.
בעקבות העצלנות שלהם, הם מתדלקים רק כאשר
אין להם מספיק דלק כדי להגיע לעיר הבאה
(כניסה לעיר עם מיכל ריק עדיין אפשרית).
ברגע שהם נאלצים לעצור בתחנת דלק,
הם תמיד ממלאים את המיכל שלהם במלואו.

רשות המיסים הצ'כית רוצה לדעת כמה מכוניות עצרו בכל
תחנת דלק במהלך היום.
בהינתן התנהגות צפויה זו, אתם אמורים להיות מסוגלים לחשב זאת בקלות.

## קלט
שורת הקלט הראשונה מכילה שני מספרים שלמים מופרדים ברווח $N$ ו-$K$ —
מספר הערים וקיבולת מיכל הדלק של כל מכונית.
$N-1$ השורות הבאות מתארות את הכבישים.
כל אחת מהן מכילה שלושה מספרים שלמים מופרדים ברווח $u_i$, $v_i$ ו-$l_i$,
כאשר $u_i$ ו-$v_i$ הם אינדקסים של ערים המחוברות על ידי הכביש ה-$i$ 
ו-$l_i$ הוא אורך הכביש הזה בקילומטרים.
הערים ממוספרות מ-$0$ עד $N-1$.
מובטח שלכל זוג ערים,
קיים מסלול אחד בדיוק ביניהן.

## פלט
עליכם להדפיס $N$ שורות, שעליהן להכיל את מספר המכוניות אשר עוצרות
בתחנת הדלק בכל עיר, מסודרות מהעיר $0$ לעיר $N - 1$.

<div style='page-break-after: always'></div>
 
## דוגמאות

### דוגמה 1

קלט:

```
3 1
0 1 1
1 2 1
```

פלט:

```
0
2
0
```

ישנן שלוש ערים בשורה המחוברות על ידי כבישים באורך 1
ומיכל הדלק בעל קיבולת של ליטר 1.
רק המכוניות הנוסעות בין שתי הערים החיצוניות יעצרו בעיר האמצעית.

### דוגמה 2

קלט:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

פלט:

```
0
3
3
12
8
0
```

הפעם ישנן 6 ערים בשורה ומיכל הדלק בעל קיבולת של 2 ליטרים.
מכוניות רבות צריכות לעצור בערים 3 ו-4.
זה הגיוני כי הערים 3 ו-4 מחוברות באמצעות
כביש באורך 2 קילומטרים.

## מגבלות
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (לכל $i$ המקיים $0 \leq i \leq N-2$)

## תתי משימות
נסמן ב-$D$ את המספר הגדול ביותר של כבישים המחוברים לעיר אחת.

1. (18 נקודות) $N \leq 1\,000, K \leq 1\,000$
2. (8 נקודות) $D\le 2$ וגם $l_i = 1$ (לכל $i$ המקיים $0 \leq i \leq N-2$)
3. (10 נקודות) $D\le 2$
4. (12 נקודות) $K\leq 10, D\leq 10$
5. (17 נקודות) $K\leq 10$
6. (35 נקודות) _ללא מגבלות נוספות_







