
# Petrol postaje

Za vrijeme dok neki novi klinci pohađaju razne olimpijade po Egiptu i sličnim državama, mladi Fabijan marljivo radi kroz ljeto. Naime, osnovao je turističku agenciju i vozit će lijepe Čehinje Lijepom Našom.

Hrvatska mreža autocesta sastoji se od $N$ gradova i $N-1$ cesta s poznatim duljinama u kilometrima. Znamo da postoji točno jedan put između svakog para gradova. Nadalje, postoji točno jedna benzinska postaja u svakom od gradova i nigdje drugdje.

Fabijan će ovo ljeto napraviti $N^2$ izleta automobilom. Zanimljivo je da će za svaki uređeni par gradova $(a,b)$ Fabijan napraviti izlet koji ide iz grada $a$ u grad $b$, putujući jedinim putem između tih gradova. Budući da su svi u Hrvatskoj jako bogati, svi voze Nevere, a svaka Nevera ima istu zapreminu spremnika goriva od $K$ jedinica i troši jednu jedinicu goriva po prijeđenom kilometru. Prije polaska, spremnik goriva svakog automobila je pun. Nadalje, Fabijan baš i ne voli planirati svoje izlete i gdje će točiti gorivo. On vozi sve dok ne dođe do grada iz kojeg ne može prijeći u sljedeći grad (ulazak u grad s praznim spremnikom je još uvijek moguć) te tamo potpuno napuni. Svaki put kad se to dogodi, Čehinja povikne: "TOČI  FABIJAN, TOČIIIIIII!!!! DO VRHAAAA!!!!!"

Hrvatska porezna uprava želi za svaku benzinsku postaju znati koliko je puta Fabijan TOČIO na njoj ovog ljeta.

## Ulazni podaci
Prvi redak ulaza sadrži dva cijela broja odvojena razmakom $N$ i $K$ — broj gradova i kapacitet spremnika goriva svakog automobila. Sljedećih $N-1$ redaka opisuju ceste. Svaki od njih sadrži tri cijela broja odvojena razmakom $u_i$, $v_i$ i $l_i$, gdje su $u_i$ i $v_i$ indeksi gradova povezanih cestom, a $l_i$ je duljina te ceste u kilometrima. Gradovi su numerirani od $0$ do $N-1$. Garantirano je da za svaki par gradova postoji točno jedan put između njih.

## Izlazni podaci
Trebate ispisati $N$ redaka. $i$-ti redak treba sadržavati broj točenja na benzinskoj postaji u $i$-tom gradu nakon svih izleta.

## Probni primjeri

### Primjer 1

Ulaz:

```
3 1
0 1 1
1 2 1
```

Izlaz:

```
0
2
0
```

Postoje tri grada u nizu povezana cestama duljine 1, a spremnik automobila ima kapacitet od 1 litre. Samo automobili koji idu između dva vanjska grada stat će u srednjem gradu.

### Primjer 2

Ulaz:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Izlaz:

```
0
3
3
12
8
0
```

Ovoga puta postoji 6 gradova u nizu, a spremnik automobila ima kapacitet od 2 litre. Mnogi automobili moraju stati u gradovima 3 i 4. To ima smisla jer su gradovi 3 i 4 povezani cestom duljine 2 kilometra.

## Ograničenja
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (za svaki $i$ tako da $0 \leq i \leq N-2$)

## Bodovanje
Neka je $D$ maksimalan broj cesta povezanih s jednim gradom.

1. (18 bodova) $N \leq 1\,000, K \leq 1\,000$
2. (8 bodova) $D \leq 2$ i $l_i = 1$ (za svaki $i$ tako da $0 \leq i \leq N-2$)
3. (10 bodova) $D \leq 2$
4. (12 bodova) $K \leq 10, D \leq 10$
5. (17 bodova) $K \leq 10$
6. (35 bodova) _bez dodatnih ograničenja_