# Benzinkutak

A cseh autópálya-hálózat $N$ városból és $N-1$ útszakaszból áll, amelyek hossza kilométerben mérve ismert.
Tudjuk, hogy minden várospár között pontosan egy útvonal létezik.
Továbbá, minden városban pontosan egy benzinkút van és sehol máshol nem található benzinkút.

Egy nap jópár ember az autóval való utazást választotta. Tudjuk, hogy aznap összesen  $N^2$ autó közlekedett.
Furcsa módon minden egyes $(a,b)$ rendezett várospárra érvényes, hogy pontosan egy autó megy az $a$ városból a $b$ városba és az autó a megadott városok közötti egyetlen útvonalon halad.

Mivel Csehországban mindenki Škodát használ, minden autónak ugyanolyan, $K$ literes üzemanyagtartálya van és minden megtett kilométeren egy liter benzint fogyaszt.
Indulás előtt minden autó üzemanyagtartálya tele van.
Ráadásul a csehek meglehetősen kiszámíthatóak. Lustaságukból adódóan csak akkor tankolnak, amikor
nincs elég benzin az autójukban a következő városig. (Üres tankkal is meg lehet érkezni egy városba).
Amikor kénytelenek megállni egy benzinkútnál, akkor viszont mindig teljesen feltöltik a tankot.

A cseh adóhatóság szeretné tudni, hogy hány autó állt meg az egyes benzinkutakon a nap folyamán.
Tekintettel az emberek kiszámítható viselkedésére, segíts nekik ezt kiszámítani.

## Bemenet
A bemenet első sora két, szóközzel elválasztott egész számot tartalmaz $N$-t és $K$-t, a városok számát és az egyes autók üzemanyagtartályának kapacitását.

A következő $N-1$ sor az útszakaszokat írja le: mindegyik sor három, szóközzel elválasztott egész számot tartalmaz: $u_i$, $v_i$ és $l_i$, ahol $u_i$ és $v_i$ az $i$-edik útszakasz által összekötött városok sorszámai és $l_i$ az útszakasz hossza kilométerben.

A városok számozása $0$-tól $N-1$-ig történik.
Minden várospár esetén közöttük pontosan egy útvonal létezik.

## Kimenet
A kimenetre $N$ sort kell kiíratnod.
Az $i$-edik sorba az $i$-edik város benzinkútjánál megálló autók száma kerüljön.

## Példák

### 1. példa

Bemenet
```
3 1
0 1 1
1 2 1
```
Kimenet
```
0
2
0
```

Három város van egy sorban, amelyet 1 hosszúságú útszakaszok kötnek össze és az autó benzintartályának űrtartalma 1 liter.
Csak a két külső város között közlekedő autók állnak meg a középső városban.

### 2. példa

Bemenet
```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```
Kimenet
```
0
3
3
12
8
0
```

Ezúttal 6 város van egy sorban és az autó tartálya 2 literes.
Sok autónak kell megállnia a 3. és 4. városban, mert a 3. és a 4. várost egy 2 kilométer hosszúságú útszakasz köti össze.

## Korlátok
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (minden $i$-re, ahol $0 \leq i \leq N-2$)

## Részfeladatok
Jelölje $D$ az egy városhoz kapcsolódó útszakaszok maximális számát.

1. (18 pont) $N \leq 1\,000, K \leq 1\,000$
2. (8 pont) $D\le 2$ és $l_i = 1$ (minden $i$-re, ahol $0 \leq i \leq N-2$)
3. (10 pont) $D\le 2$
4. (12 pont) $K\leq 10, D\leq 10$
5. (17 pont) $K\leq 10$
6. (35 pont) _nincs további megkötés_
