# Stacje Benzynowe

Czeska infrastruktura drogowa składa się z $N-1$ autostrad łączących $N$ miast.
Pomiędzy każdą parą miast istnieje dokładnie jedna trasa.
Jest tam również dokładnie $N$ stacji benzynowych – po jednej w każdym mieście.

Z okazji CEOI 2024 spora grupa mieszkańców wpadła w podróżniczy trans.
W drogę wyruszyło $N^2$ samochodów,
po jednym bezpośrednim z każdego miasta $a$ do każdego miasta $b$.
Jako, że wszyscy w Czechach jeżdżą Škodami,
wszystkie auta mają tę samą pojemność baku $K$ oraz to samo spalanie, wynoszące dla uproszczenia jedną jednostkę paliwa na jeden kilometr jazdy.
Przed wyruszeniem w drogę każde z aut jest zatankowane do pełna.
Czesi są nadzwyczaj przewidywalni.
Tankują swoje auta wyłącznie wtedy, 
kiedyby zabrakło im benzyny przed dojazdem do kolejnego miasta na trasie (dozwolone jest jednak, by benzyna skończyła się dokładnie w momencie dotarcia do tegoż miasta).
Kiedy już tankują, to zawsze do pełna.

Czeskie Ministerstwo Skarbu chciałoby wiedzieć, ile samochodów zatankowało w każdym z miast.
Z uwagi na przewidywalność Czechów, obliczenie tego powinno się udać!

## Wejście
W pierwszym wierszu wejścia znajdą się dwie liczby całkowite $N$ i $K$
– liczba miast oraz pojemność baku Škody w jednostkach paliwa.
Każdy z kolejnych $N-1$ wierszy opisuje jedną z autostrad.
Opis autostrady to trzy liczby całkowite $u_i$, $v_i$ i $l_i$, 
oznaczające numery miast, które łączy $i$-ta autostrada, oraz jej długość w kilometrach.
Miasta są numerowane od $0$ do $N-1$.
Zagwarantowanym jest, że pomiędzy każdą parą miast będzie istniała dokładnie jedna trasa.

## Wyjście
Na wyjście wypisz $N$ wierszy.
Wiersz $i$-ty powinien zawierać jedną liczbę
– aut, które zatankowały z okazji podróżniczego transu w mieście nr $i - 1$.

## Przykłady

### Przykład 1

Wejście:

```
3 1
0 1 1
1 2 1
```

Wyjście:

```
0
2
0
```

W Czechach są trzy miasta połączone drogami o długości 1km,
a bak pomieści jedną jednostkę paliwa.
Aby zatankować zatrzymają się jedynie auta jadące pomiędzy skrajnymi miastami.

### Przykład 2

Wejście:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Wyjście:

```
0
3
3
12
8
0
```

Tym razem w Czechach mamy sześć miast połączonych sznurem autostrad.
W miastach nr 3 i nr 4 zatrzyma się najwięcej aut, 
ponieważ są połączone drogą o długości 2 kilometrów.

## Ograniczenia
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (dla $0 \leq i \leq N-2$)

## Podzadania
Niech $D$ oznacza ograniczenie na liczbę autostrad spotykających się w jednym mieście.

1. (18 punktów) $N \leq 1\,000, K \leq 1\,000$
2. (8 punktów) $D \le 2$ oraz $l_i = 1$
3. (10 punktów) $D\le 2$
4. (12 punktów) $K\leq 10, D\leq 10$
5. (17 punktów) $K\leq 10$
6. (35 punktów) _brak dodatkowych ograniczeń_
