# Petrol stations

Rețeaua de autostrăzi din Cehia constă din $N$ orașe și $N-1$ drumuri, ale căror lungimi sunt cunoscute și măsurate în kilometrii.
Știm că există o singură cale între oricare pereche de orașe.
Cu atât mai mult, există o singură benzinărie în fiecare oraș și nicăieri în altă parte.

Într-o zi, mai mulți oameni s-au decis să plece într-o excursie cu mașina.
Numărul total de mașini din excursii a fost $N^2$.

În mod ciudat, pentru fiecare pereche ordonată de orașe $(a,b)$ a existat o singură mașină care a plecat din orașul $a$ spre orașul $b$, mergând pe singura cale dintre cele două orașe. Din moment ce fiecare om din Cehia conduce Škoda, fiecare mașină are aceeași capacitate a rezervorului de $K$ litrii și consumă constant un litru de benzină pe fiecare kilometru parcurs.
Înainte de plecare, rezervorul fiecărei mașini este plin. Cu atât mai mult, cehii sunt destul de predictibili. Din cauza comodității, ei alimentează doar dacă nu au destulă benzină să ajungă la următorul oraș (este posibil să ajungi într-un oraș cu rezervorul gol). O dată ce sunt forțați să oprească la o benzinărie, fac plinul.

Autoritățiile din Cehia, și-ar dori să știe câte mașini au oprit la fiecare benzinărie în acea zi.
Acestea fiind spuse, ar trebui să poți calcula ușor acest lucru.

## Input

Prima linie conține două numere întregi separate prin câte un spațiu, $N$ și $K$ — numărul de orașe și capacitatea fiecărui rezervor.

Următoarele $N-1$ linii descriu drumurile.
Pe fiecare dintre ele se află trei numere întregi separate prin câte un spațiu, $u_i$, $v_i$ și $l_i$, unde $u_i$ și $v_i$ sunt indicii orașelor conectate de drum și $l_i$ este lungime drumului în kilometrii.
Orașele sunt numerotate de la $0$ la $N-1$.
Se garantează că pentru fiecare pereche de orașe, există exact o cale între ele.

## Output
Trebuie afișate pe $N$ linii numărul de mașini care s-au oprit la stația de petrol dintr-un oraș, în ordine crescătoare a numărului de ordine ale orașelor.

## Exemple

### Exemplul 1

Input:

```
3 1
0 1 1
1 2 1
```

Output:

```
0
2
0
```

Sunt trei orașe conectate printr-o singură linie de drumuri de lungime 1 și rezervorul mașinilor are capacitatea de 1 litru.
Doar mașinile care merg între două orașe de margine se vor opri în orașul din mijloc.

### Exemplul 2

Input:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Output:

```
0
3
3
12
8
0
```

De data aceasta sunt 6 orașe într-o linie și rezervorul mașinii are o capacitate de 2 litrii.
Mai multe mașini trebuie să se oprească în orașul 3 sau 4. Acest lucru are sens deoarece orașele 3 și 4 sunt conectate printr-un drum de lungime 2 kilometrii.


## Restricții
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (oricare ar fi $i$ astfel încât $0 \leq i \leq N-2$)

## Grupe
Fie $D$ numărul maxim de drumuri incidente într-un singur oraș.

1. (18 puncte) $N \leq 1\,000, K \leq 1\,000$
2. (8 puncte) $D\le 2$ și $l_i = 1$ (oricare ar fi $i$ astfel încât $0 \leq i \leq N-2$)
3. (10 puncte) $D\le 2$
4. (12 puncte) $K\leq 10, D\leq 10$
5. (17 puncte) $K\leq 10$
6. (35 puncte) _fără alte restricții_
