# Kŕmne stanice

V Amazonskom pralese sa nachádza $N$ osád. Keďže každá výstavba chodníka vyžaduje obetu našich bratov stromov, Amazonská dopravná sieť pozostáva iba z $N-1$ rýchlostných chodníkov (vedúcich medzi dvoma osadami) so známou dĺžkou v kilometroch.
Vieme, že medzi každou dvojicou osád existuje presne jedna cesta.
Okrem toho v každej z osád existuje presne jedna kŕmna stanica (a nikde inde).

Blíži sa obdobie oslavných rituálov a s ním aj masívne sťahovanie domorodcov. Pre úspešný rituál je v každej osade potrebná prítomnosť člena každej osady a teda v najbližších dňoch môžeme pozorovať presun $N^2$ domorodcov. Pre každú usporiadanú dvojicu osád $(a,b)$ nasadne jeden domorodec z osady $a$ na anakondu a poputuje do osady $b$ trasou idúcou po jedinej ceste medzi týmito osadami.
Domestifikované prepravné anakondy sú vyšľachtené tak, že všetky majú objem žalúdka na $K$ myší a na jeden prejdený kilometer strávia rovnomerne jednu myš.
Pred odchodom sú všetky anakondy nakŕmené dosýta a ich žalúdky sú plné.
Správanie domorodcov počas presunu je presne stanovené rituálom, a tak zastavujú na kŕmnych staniciach a kŕmia svoje anakondy len vtedy, keď už nemajú dostatok živín na dojazd do ďalšej osady (vjazd do osady s prázdnym žalúdkom je stále možný).
Rituál tiež nariaďuje, že každé kŕmenie musí naplniť žalúdok anakondy do plna.

Aby tohtoročný rituál prebehol hladko, každá osada by rada vedela, koľko anakond zastaví v jej kŕmnej stanici.
Vzhľadom na toto rituálne správanie by ste to mali byť schopní ľahko vypočítať.

## Vstup
Prvý riadok vstupu obsahuje dve celé čísla oddelené medzerou $N$ a $K$ -
počet osád a objem žalúdka každej anakondy.
Nasledujúcich $N-1$ riadkov opisuje rýchlostné chodníky.
Každý z nich obsahuje tri celé čísla oddelené medzerou $u_i$, $v_i$ a $l_i$,
kde $u_i$ a $v_i$ sú indexy osád spojených $i$-tym chodníkom a
$l_i$ je dĺžka tohoto chodníka v kilometroch.
Osady sú očíslované od $0$ po $N-1$.
Je zaručené, že pre každú dvojicu osád
existuje presne jeden chodník medzi nimi.

## Výstup
Na výstupe je $N$ riadkov, ktoré obsahujú počet anakond zastavujúcich na kŕmnej stanici
v každej osade, zoradené od osady $0$ po osadu $N - 1$.

## Príklady

### Príklad 1

Vstup:

```
3 1
0 1 1
1 2 1
```

Výstup:

```
0
2
0
```

V rade sú tri osady spojené chodníkmi dĺžky 1
a žalúdky majú objem na 1 myš.
V strednej osade zastavia len anakondy, ktoré idú medzi dvoma krajnými osadami.

### Príklad 2

Vstup:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Výstup:

```
0
3
3
12
8
0
```

Tentoraz je v rade 6 osád a žalúdky majú objem na 2 myši.
Mnoho anakond musí zastaviť v osadách 3 a 4, čo dáva zmysel, keďže osady 3 a 4 sú spojené
chodníkom s dĺžkou 2 km.

## Obmedzenia
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (pre každé $i$ také, že $0 \leq i \leq N-2$)

## Podúlohy
Nech $D$ označuje maximálny počet chodníkov pripojených k jednej osade.

1. (18 bodov) $N \leq 1\,000, K \leq 1\,000$
2. (8 bodov) $D\le 2$ and $l_i = 1$ (pre každé $i$ také, že $0 \leq i \leq N-2$)
3. (10 bodov) $D\le 2$
4. (12 bodov) $K\leq 10, D\leq 10$
5. (17 bodov) $K\leq 10$
6. (35 bodov) _žiadne ďalšie obmedzenia_
