# Bencinske črpalke

V češko avtocestno omrežje je z $N-1$ cestami povezanih $N$ mest; za vse ceste poznamo njihove dolžine (v kilometrih, kakopak) in tudi vemo, da med vsakima dvema mestoma obstaja natanko ena pot. Črpalke so samo v mestih, in sicer v vsakem natanko ena.

Nekega lepega dne se je kar nekaj ljudi odločilo, da bo šlo na izlet z avtom. Skupaj je bilo na cestah $N^2$ potujočih avtomobilov. Zdi se čudno, ampak v resnici je veljalo celo, da je za vsak urejen par $(a, b)$ iz mesta $a$ v mesto $b$ potoval natanko en avto, po edini poti med mestoma. Ker na Češkem vsi vozijo avtomobile znamke Škoda (Simply Clever!), vemo tudi, da ima vsaka Škoda tank velikosti $K$ in porabi en liter goriva na prevožen kilometer.
Pred odhodom so vsi tanki polni. Ker pa so Čehi tudi zelo predvidljivi, leni in na splošno češki, vemo, da se bodo ustavili na črpalki samo, če ne bodo imeli dovolj goriva, da bi dosegli naslednje mesto. Ko se enkrat končno ustavijo na neki črpalki, tank vedno napolnijo do konca. V mesto se je mogoče pripeljati s tankom, ki se ravno takrat izprazni.

Zaradi _državi prijaznih_ trošarin češki davčni urad zanima, koliko avtomobilov se je čez dan ustavilo na vsaki izmed črpalk. Ker je obnašanje čeških avtomobilistov tako predvidljivo, ti izračun tega ne bi smel predstavljati prevelikega problema.

## Vhodni podatki

V prvi vrstici sta s presledkom ločeni celi števili $N$, število mest, in $K$, velikost tankov Škodinih avtomobilov.
Naslednjih $N-1$ vrstic opisuje avtocestno omrežje; v vsaki vrstici so tri s presledki ločena cela števila:

- $u_i$ in $v_i$ sta zaporedni številki dveh mest, med katerima je direktna avtocestna povezava,
- $l_i$, ki je dolžina te ceste v kilometrih.

Mesta so oštevilčena od $0$ do $N-1$. Zagotovo bo med vsakima dvema mestoma obstajala natanko ena pot po avtocestnem omrežju.

## Izhodni podatki

Za vsako mesto po vrsti od $0$ do $N-1$ v svoji vrstici izpiši število avtomobilov, ki so tankali v tem mestu.

## Primeri

### 1. primer

Vhod:

```
3 1
0 1 1
1 2 1
```

Izhod:

```
0
2
0
```

V državi so tri mesta, zaporedoma povezana z dvema cestama dolžine 1, avtomobili pa imajo enolitrske tanke. Na črpalki v srednjem mestu se ustavita samo avtomobila, ki potujeta med robnima dvema mestoma.

### 2. primer

Vhod:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Izhod:

```
0
3
3
12
8
0
```

Tokrat je v omrežju 6 mest, tanki pa so dvolitrski. Več avtomobilov se mora ustaviti v mestih 3 in 4, saj sta ti dve mesti povezani s cesto dolžine 2 kilometra.

## Omejitve
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (za vsak $i$, da $0 \leq i \leq N-2$)

## Podnaloge

Označimo z $D$ največje število cest, ki vodijo v eno mesto.

1. (18 točk) $N \leq 1\,000, K \leq 1\,000$
2. (8 točk) $D\le 2$ in $l_i = 1$ (za vsak $i$, da $0 \leq i \leq N-1$)
3. (10 točk) $D\le 2$
4. (12 točk) $K\leq 10, D\leq 10$
5. (17 točk) $K\leq 10$
6. (35 točk) _brez dodatnih omejitev_
