# Петро на Леопарді

Головонокомандуючий доручив новому керівнику Об'єднаних військ проаналізувати використання переданих танків Leopard західними партнерами. У засекречених документах зазначається, що мережа шляхів складається з $N$ міст і $N-1$ доріг з відомими довжинами доріг в кілометрах. Також у документах затверджено, що існує рівно один шлях між кожною парою міст. Крім того, у кожному з міст є рівно одна заправна станція для танків.

З польового журналу тактичних дій стало відомо, що одного дня декілька тактичних груп вирушили на бойове завдання. Загалом в завданні приймало участь $N^2$ танків. Дивно, але для кожної впорядкованої пари міст $(a,b)$ був рівно один танк, що їхав з міста $a$ до міста $b$, подорожуючи єдиним шляхом між цими містами. В цій операції застосовувалися лише танки Leopard, що мають однакову ємність паливного бака $K$ літрів і постійно споживають один літр бензину на кілометр шляху. Перед від'їздом паливний бак кожного танку повний. Через вказівки командирів, військові мають заправлятися лише тоді, коли у них недостатньо бензину, щоб доїхати до наступного міста (в'їзд до міста з порожнім баком все одно можливий). При цьому, якщо вони все ж заїхали на заправну станцію, вони мають завжди повністю заправити свій бак.

Командуючий Об'єднаними силами хоче знати, скільки танків Leopard зупинилися на кожній
заправній станції протягом дня, щоб розприділити наявні системи ППО для захисту станцій. Враховуючи таку передбачувану поведінку, ви повинні легко це обчислити.


## Формат вхідних даних

Перша строка вхідних даних містить два цілі числа, розділені пробілом, $N$ і $K$ —
кількість міст і ємність паливного бака кожного танку. 

Наступні $N-1$ рядків описують дороги. Кожна з них містить три цілі числа, розділені пробілом: $u_i$, $v_i$ та $l_i$, де $u_i$ і $v_i$ — індекси міст, які з'єднані $i$-ою дорогою, а $l_i$ — довжина цієї дороги в кілометрах.

Міста пронумеровані від $0$ до $N-1$. Гарантується, що для кожної пари міст існує рівно один шлях між ними.

## Формат вихідних даних

Ви повинні вивести $N$ рядків, кожен з яких має містити кількість танків, які зупинилися на заправній станції в кожному місті, в порядку від міста $0$ до міста $N - 1$.


## Приклади

### Приклад 1

Вхідні дані:

```
3 1
0 1 1
1 2 1
```

Вихідні дані:

```
0
2
0
```

Уявімо три міста, розташовані в лінію і з'єднані дорогами довжиною 1 км, причому ємність паливного бака танка складає 1 літр. Лише танки, що їдуть між двома крайніми містами, зупиняться в середньому місті.
<div style='page-break-after: always'></div>.

### Приклад 2

Вхідні дані:

```
6 2
0 1 1
1 2 1
2 3 1
3 4 2
4 5 1
```

Вихідні дані:

```
0
3
3
12
8
0
```

Цього разу є 6 міст, розташованих в лінію, і ємність паливного бака танка складає 2 літри.
Багато автомобілів мають зупинитися в містах 3 та 4. Це має сенс, оскільки міста 3 і 4 з'єднані дорогою довжиною 2 кілометри.

## Обмеження
- $2 \leq N \leq 70\,000$
- $1 \leq K \leq 10^9$
- $0 \leq l_i \leq K$ (для кожного $i$ такого, що $0 \leq i \leq N-2$)

## Підзадачі
Нехай $D$ позначає максимальну кількість доріг, що з'єднують одне місто.

1. (18 балів) $N \leq 1\,000, K \leq 1\,000$
2. (8 балів) $D\le 2$ та $l_i = 1$ (для кожного $i$ такого, що $0 \leq i \leq N-1$)
3. (10 балів) $D\le 2$
4. (12 балів) $K\leq 10, D\leq 10$
5. (17 балів) $K\leq 10$
6. (35 балів) _без додаткових обмежень_
